/*******************************
 * 
 * 骑享程序V2版本
 * 
 * ****************************/
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "app.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include <cis_def.h>
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"

//基础定义
#define Batt_Cell_Num  (17)//默认数值14、17
#define Batt_Temp_Num  (7)//默认数值5、7
#define Batt_Cell_Num_2 (Batt_Cell_Num*2)
//主任务调度定义
#define PROC_MAIN_TASK_STACK_SIZE           (512)
static StaticTask_t             gProcess_Main_Task_t;
static UINT8                  gProcess_Main_TaskStack[PROC_MAIN_TASK_STACK_SIZE];
uint8_t deepslpTimerID          = DEEPSLP_TIMER_ID7;
uint8_t MainSlpHandler          = 0xff;
typedef enum
{
    PROCESS_STATE_IDLE = 0,
    PROCESS_STATE_WORK,
    PROCESS_STATE_SLEEP
}process_Main;
static process_Main 		    gProcess_Main_Task = PROCESS_STATE_IDLE;
#define PROC_MAIN_STATE_SWITCH(a)  (gProcess_Main_Task = a)
volatile bool Sleep_Flag = false;//主线程睡眠标志位
//Uart线程定义 
#define PROC_UART_TASK_STACK_SIZE           (1024)
static StaticTask_t             gProcess_Uart_Task_t;
static UINT8                  gProcess_Uart_TaskStack[PROC_UART_TASK_STACK_SIZE];

#define Uart_Send_LEN         (8)
#define Uart_Rece_LEN         (50)
#define battbuffer_len         (110)
#define RTE_UART_RX_IO_MODE      RTE_UART1_RX_IO_MODE
extern ARM_DRIVER_USART Driver_USART1;
static ARM_DRIVER_USART *USARTdrv = &Driver_USART1;
volatile bool isRecvTimeout = false;
volatile bool isRecvComplete = false;
typedef enum
{
    PROCESS_UART_STATE_IDLE = 0,
    PROCESS_UART_STATE_CHECK,
    PROCESS_UART_STATE_WORK,
    PROCESS_UART_STATE_SLEEP
}process_Uart;
static process_Uart             gProcess_Uart_Task = PROCESS_UART_STATE_IDLE;
#define PROC_UART_STATE_SWITCH(a)  (gProcess_Uart_Task = a)
volatile bool Uart_Sleep_State = false;
uint8_t UartSlpHandler          = 0xfe;
//Fota线程定义
#define PROC_FOTA_TASK_STACK_SIZE           (1024)
static StaticTask_t             gProcess_Fota_Task_t;
static UINT8                  gProcess_Fota_TaskStack[PROC_FOTA_TASK_STACK_SIZE];
Fota_Type Fota_Struct;
//CAN线程定义

//Tcp线程定义

//GPS线程定义
#define PROC_GPS_TASK_STACK_SIZE   				(1024)
static QueueHandle_t gpsMsgQueue = NULL;
static QueueHandle_t norGpsHandle = NULL;
static osThreadId_t gpsTaskHandle = NULL;
static UINT8                   gProcess_Gps_TaskStack[PROC_GPS_TASK_STACK_SIZE];
static StaticTask_t gProcess_Gps_Task_t = NULL;
GPS_INFO Gps_Data;

//函数声明区
void Uart_func(void);
void USART_callback(uint32_t event);
//睡眠进出函数
static void appBeforeHib(void *pdata, slpManLpState state)
{
    uint32_t *p_param = (uint32_t *)pdata;

    #ifdef USING_PRINTF
        printf("Before Hibernate:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);

}
static void appAfterHib(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("Try Hibernate Failed:%d \n",state);
    #endif
}
static void appBeforeSlp1(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("Before Sleep1:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);
}
static void appAfterSlp1(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("After Sleep1:%d \n",state);
    #endif
}
static void appBeforeSlp2(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("before sleep2:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);
}
static void appAfterSlp2(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("sleep2 failed:%d \n",state);
    #endif
}
// 主任务线程
static void Main_Task(void* arg)
{
    uint32_t sleep_count = 0;
    uint32_t Uart_time = 0;
    uint32_t sleep_time_value;
    int32_t inParam = 0xAABBCCDD;
    uint32_t Chrgend_Work_time = 18000;
    uint32_t Wakeup_Work_time = 3000;
    uint32_t Sleep_Time = 20000;
    //上述参数应写入文件里
    slpManSlpState_t State;
    uint8_t cnt;
    slpManWakeSrc_e Wakeup_source;

    NetSocDisplay(LED_SOC_0,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_1,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_2,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_3,LED_TURN_OFF);
    FaultDisplay(LED_TURN_OFF);
    NVIC_EnableIRQ(PadWakeup1_IRQn);
    slpManSetPmuSleepMode(true,SLP_HIB_STATE,false);
    slpManApplyPlatVoteHandle("MainSlp",&MainSlpHandler);
    slpManRegisterUsrdefinedBackupCb(appBeforeHib,&inParam,SLPMAN_HIBERNATE_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterHib,NULL,SLPMAN_HIBERNATE_STATE);
    slpManRegisterUsrdefinedBackupCb(appBeforeSlp1,NULL,SLPMAN_SLEEP1_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterSlp1,NULL,SLPMAN_SLEEP1_STATE);
    slpManRegisterUsrdefinedBackupCb(appBeforeSlp2,NULL,SLPMAN_SLEEP2_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterSlp2,NULL,SLPMAN_SLEEP2_STATE);

    slpManPlatVoteDisableSleep(MainSlpHandler, SLP_SLP1_STATE); 
    slpManSlpState_t slpstate = slpManGetLastSlpState();
    #ifdef USING_PRINTF
            printf("slpstate:%d \n",slpstate);
    #endif
    Wakeup_source =  slpManGetWakeupSrc();//获取唤醒源
    #ifdef USING_PRINTF
            printf("Wakeup_source:%d \n",Wakeup_source);
    #endif
    PROC_MAIN_STATE_SWITCH(PROCESS_STATE_IDLE);
    if (Wakeup_source==0)
    {
        sleep_time_value = Wakeup_Work_time;
    }
    else if (Wakeup_source==1)
    {
        sleep_time_value = Wakeup_Work_time;
    }
    else
    {
        sleep_time_value = Chrgend_Work_time;
    }
    if((slpstate == SLP_SLP2_STATE) || (slpstate == SLP_HIB_STATE))
    {
        PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
    }
    else
    {
        PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
    }
    //线程初始化完成
    while (true)
    {
        switch(gProcess_Main_Task)
        {
            case PROCESS_STATE_IDLE:
            {
                PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
                break;
            }
            case PROCESS_STATE_WORK:
            {
                osDelay(100/portTICK_PERIOD_MS);
                sleep_count++;
                Uart_time++;
                if (Uart_time >10)
                {
                    Uart_time = 0;
                    PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_WORK);
                }



                if(Fota_Struct.Fota_update)
                {
                    sleep_count = 0;
                }
                if (sleep_count >=sleep_time_value)
                {
                    PROC_MAIN_STATE_SWITCH(PROCESS_STATE_SLEEP);
                    sleep_count = 0;
                }
                break;
            }
            case PROCESS_STATE_SLEEP:
            {
                #ifdef USING_PRINTF
                        printf("[%d]Main_sleep\r\n",__LINE__);
                #endif
                while(true)
                {
                    PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_SLEEP);
                    if(Uart_Sleep_State)
                        break;
                    Sleep_Flag = true;
                    #ifdef USING_PRINTF
                        printf("Uart_Sleep_State:%d\r\n",Uart_Sleep_State);
                    #endif
                    osDelay(1000/portTICK_PERIOD_MS);
                }
                if(slpManCheckVoteState(MainSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Main State, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif						
                }
                slpManPlatVoteForceEnableSleep(MainSlpHandler, SLP_SLP1_STATE); //增加强制投票
                if(slpManCheckVoteState(MainSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Main State Again, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif					
                }
                #ifdef USING_PRINTF
                            printf("[%d]Waiting sleep\r\n",__LINE__);
                #endif
                slpManSlpState_t slpstate = slpManPlatGetSlpState();
                #ifdef USING_PRINTF
                    printf("which slpstate can go now :%d \n",slpstate);
                #endif
                slpManDeepSlpTimerStart(deepslpTimerID, Sleep_Time);
                while(1)
                {
                    if(!slpManDeepSlpTimerIsRunning(deepslpTimerID))
                    {
                        slpManDeepSlpTimerDel(deepslpTimerID);
                    }
                    slpManDeepSlpTimerStart(deepslpTimerID, Sleep_Time);
                    osDelay(60000/portTICK_PERIOD_MS);
                }
            }
        }
    }
}
//Uart校验程序
unsigned int crc_chk(uint8_t* data, uint8_t length)
{  
    int j;
    uint16_t reg_crc=0xFFFF;
    while(length--)
    { 
        reg_crc ^= *data++;
        for(j=0;j<8;j++)
        { 
            if(reg_crc & 0x01)
            {
                reg_crc=(reg_crc>>1) ^ 0xA001;
            }
            else
            {
                reg_crc=reg_crc >>1;
            }
        }
    }
    return reg_crc;
}
//Uart发送接收函数
uint8_t* Uart_Receive_send_func(Uart_Receive_Type Uart_Receive_Msg,uint8_t* Uart_Rece_buffer,uint8_t Data_Len)
{
    uint16_t CRC_Rece_buffer;
    uint16_t CRC_chk_buffer;
    uint8_t Uart_Send_buffer[8];
    Uart_Send_buffer[0] = Uart_Receive_Msg.Bms_Address;
    Uart_Send_buffer[1] = Uart_Receive_Msg.Bms_Read_Funcode;
    Uart_Send_buffer[2] = Uart_Receive_Msg.Reg_Begin_H;
    Uart_Send_buffer[3] = Uart_Receive_Msg.Reg_Begin_L;
    Uart_Send_buffer[4] = Uart_Receive_Msg.Reg_Num_H;
    Uart_Send_buffer[5] = Uart_Receive_Msg.Reg_Num_L;
    CRC_chk_buffer = crc_chk(Uart_Send_buffer,6);
    Uart_Send_buffer[6] = CRC_chk_buffer;
    Uart_Send_buffer[7] = CRC_chk_buffer>>8;
    uint32_t timeout = 0x00000000;
    USARTdrv->Send(Uart_Send_buffer,8);
    USARTdrv->Receive(Uart_Rece_buffer,Data_Len);
    while((isRecvTimeout == false) && (isRecvComplete == false))
    {
        timeout++;
        osDelay(100);
        if (timeout>=10)
        {
            timeout =0;
            isRecvTimeout = true;
            break;
        }
    }
    if (isRecvComplete == true)
    {
        isRecvComplete = false;
        CRC_Rece_buffer =*(Uart_Rece_buffer+Data_Len-1)<<8|*(Uart_Rece_buffer+Data_Len-2);
        CRC_chk_buffer = crc_chk(Uart_Rece_buffer,Data_Len-2);
        if (CRC_Rece_buffer == CRC_chk_buffer)//满足校验
        {
            return Uart_Rece_buffer;//此处指针移位出现重启问题
        }
        else //接收数据的校验不过
        {
            USARTdrv->Uninitialize();
            USARTdrv->Initialize(USART_callback);
            USARTdrv->PowerControl(ARM_POWER_FULL);
            USARTdrv->Control(ARM_USART_MODE_ASYNCHRONOUS |
                      ARM_USART_DATA_BITS_8 |
                      ARM_USART_PARITY_NONE |
                      ARM_USART_STOP_BITS_1 |
                      ARM_USART_FLOW_CONTROL_NONE, 9600);
            memset(Uart_Rece_buffer,0xff,Data_Len);
            return Uart_Rece_buffer;
        }
    }
    else
    {
        memset(Uart_Rece_buffer,0x00,Data_Len);
        isRecvTimeout = false;
        return Uart_Rece_buffer;
    }
}
//Uart回调程序
void USART_callback(uint32_t event)
{
    if(event & ARM_USART_EVENT_RX_TIMEOUT)
    {
        isRecvTimeout = true;
    }
    if(event & ARM_USART_EVENT_RECEIVE_COMPLETE)
    {
        isRecvComplete = true;
    }
}
//Uart读取函数
void Uart_func(void)
{
    Uart_Receive_Type Uart_Receive_Msg;
    Uart_Receive_Msg.Bms_Address = 0x01;
    Uart_Receive_Msg.Bms_Read_Funcode = 0x03;
    int Rece_index = 0;
    uint8_t *Uart_Rece_buffer = NULL;
    volatile bool Uart_task = false;
    volatile  uint8_t Data_Len;
    Uart_Rece_buffer = (uint8_t *)malloc(Uart_Rece_LEN);
    while(!Uart_task)
    {
        switch (Rece_index)
        {
            case 0://current
            {
                Uart_Receive_Msg.Reg_Begin_H = 0x00;
                Uart_Receive_Msg.Reg_Begin_L= 0x02+Batt_Cell_Num;
                Uart_Receive_Msg.Reg_Num_H = 0x00;
                Uart_Receive_Msg.Reg_Num_L = 0x01;
                Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                memset(Uart_Rece_buffer,0x00,Data_Len);
                Uart_Rece_buffer = Uart_Receive_send_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                break;
            }
            case 1://cell votage
            {
                Uart_Receive_Msg.Reg_Begin_H = 0x00;
                Uart_Receive_Msg.Reg_Begin_L = 0x02;
                Uart_Receive_Msg.Reg_Num_H = Batt_Cell_Num>>8;
                Uart_Receive_Msg.Reg_Num_L = Batt_Cell_Num;
                Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                memset(Uart_Rece_buffer,0x00,Data_Len);
                Uart_Rece_buffer = Uart_Receive_send_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                break;
            }
            case 2://temprature
            {
                Uart_Receive_Msg.Reg_Begin_H = 0x00;
                Uart_Receive_Msg.Reg_Begin_L = 0x06+Batt_Cell_Num;
                Uart_Receive_Msg.Reg_Num_H = Batt_Temp_Num>>8;
                Uart_Receive_Msg.Reg_Num_L = Batt_Temp_Num;
                Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                memset(Uart_Rece_buffer,0x00,Data_Len);
                Uart_Rece_buffer = Uart_Receive_send_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                break;
            }
            case 3://batt votage
            {
                Uart_Receive_Msg.Reg_Begin_H = 0x00;
                Uart_Receive_Msg.Reg_Begin_L = 0x18+Batt_Cell_Num+Batt_Temp_Num;
                Uart_Receive_Msg.Reg_Num_H = 0x00;
                Uart_Receive_Msg.Reg_Num_L = 0x01;
                Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                memset(Uart_Rece_buffer,0x00,Data_Len);
                Uart_Rece_buffer = Uart_Receive_send_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                break;
            }
            case 4://soc,soh
            {
                Uart_Receive_Msg.Reg_Begin_H = 0x00;
                Uart_Receive_Msg.Reg_Begin_L = 0x09+Batt_Cell_Num+Batt_Temp_Num;
                Uart_Receive_Msg.Reg_Num_H = 0x00;
                Uart_Receive_Msg.Reg_Num_L = 0x04;
                Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                memset(Uart_Rece_buffer,0x00,Data_Len);
                Uart_Rece_buffer = Uart_Receive_send_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                break;
            }
            case 5://均衡
            {
                Uart_Receive_Msg.Reg_Begin_H = 0x00;
                Uart_Receive_Msg.Reg_Begin_L = 0x06+Batt_Cell_Num+Batt_Temp_Num;
                Uart_Receive_Msg.Reg_Num_H = 0x00;
                Uart_Receive_Msg.Reg_Num_L = 0x02;
                Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                memset(Uart_Rece_buffer,0x00,Data_Len);
                Uart_Rece_buffer = Uart_Receive_send_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                break;
            }
            case 6://最高最低温度和加热和充放电MOS控制
            {
                Uart_Receive_Msg.Reg_Begin_H = 0x00;
                Uart_Receive_Msg.Reg_Begin_L = 0x19+Batt_Cell_Num+Batt_Temp_Num;
                Uart_Receive_Msg.Reg_Num_H = 0x00;
                Uart_Receive_Msg.Reg_Num_L = 0x04;
                Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                memset(Uart_Rece_buffer,0x00,Data_Len);
                Uart_Rece_buffer = Uart_Receive_send_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                break; 
            }
            default:
            {
                PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_IDLE);
                Uart_task = true;
                break;
            }
        }
        Rece_index++;
    }
    free(Uart_Rece_buffer);
}
//Uart线程
static void Uart_Task(void* arg)
{
    USARTdrv->Initialize(USART_callback);
    USARTdrv->PowerControl(ARM_POWER_FULL);
    USARTdrv->Control(ARM_USART_MODE_ASYNCHRONOUS |
                      ARM_USART_DATA_BITS_8 |
                      ARM_USART_PARITY_NONE |
                      ARM_USART_STOP_BITS_1 |
                      ARM_USART_FLOW_CONTROL_NONE, 9600);
    slpManApplyPlatVoteHandle("UARTSLP",&UartSlpHandler);
    slpManPlatVoteDisableSleep(UartSlpHandler, SLP_SLP2_STATE); 
	PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_IDLE);
    uint16_t temp;
    while (true)
    {
        switch (gProcess_Uart_Task)
        {
            case PROCESS_UART_STATE_IDLE:
            {   
                NetSocDisplay(LED_SOC_0,LED_TURN_OFF);
                break;
            }
            case PROCESS_UART_STATE_WORK:
            {
                BSP_QSPI_Read_Safe(&temp,0x318000,2);
                #ifdef USING_PRINTF
                        printf("V0003!,Fota_flag:%c%c\n",temp,temp>>8);
                #endif
                //Uart_func();//读取函数运行
                PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_IDLE);
                break;
            }
            case PROCESS_UART_STATE_SLEEP:
            {
                slpManPlatVoteEnableSleep(UartSlpHandler, SLP_SLP2_STATE);
                Uart_Sleep_State = true;
                USARTdrv->PowerControl(ARM_POWER_LOW);
                #ifdef USING_PRINTF
                    printf("UART_STATE_SLEEP\n");
                #endif
                while(1)
                {
                    osDelay(3000/portTICK_PERIOD_MS);
                }
            }
        }
    }
}
uint8_t Fota_crc_chk(uint8_t* data,uint8_t length)
{  
    uint8_t reg_crc=0x00;
    while(length--)
    { 
        reg_crc ^= *data++;
    }
    return reg_crc;
}
//Fota线程
static void Fota_Task(void* arg)
{   
    Fota_Struct.Fota_Current_Addres = 0x00000000;
    Fota_Struct.Fota_Recv_Data_Len=100;
    uint8_t Uart_Rece_buffer[110];
    uint8_t temp[1];
    uint8_t Uart_Send_buffer[6] = {0x00,0x00,0x00,0x00,0x64,0x01};
    uint8_t timeout = 0x00;
    uint8_t Fota_Crc;
    uint32_t Recv_Address;
    Fota_Struct.Fota_Flash_Addres = 0x2A0000;
    osDelay(1000);
    USARTdrv->Send(Uart_Send_buffer,6);
    while (true)
    {
        osDelay(500);
        USARTdrv->Receive(Uart_Rece_buffer,110);
        Fota_Struct.Fota_update = FALSE;
        while((isRecvTimeout == false) && (isRecvComplete == false))
        {
            timeout++;
            osDelay(100);
            if (timeout>=50)
            {
                timeout =0;
                isRecvTimeout = true;
                break;
            }
        }
        if (isRecvComplete == true)
        {
            isRecvComplete == false;
            Fota_Struct.Fota_All_Data_Len = Uart_Rece_buffer[0]<<24|Uart_Rece_buffer[1]<<16|Uart_Rece_buffer[2]<<8|Uart_Rece_buffer[3];
            Fota_Crc = Fota_crc_chk(&Uart_Rece_buffer[9],Fota_Struct.Fota_Recv_Data_Len);
            Recv_Address = Uart_Rece_buffer[4]<<24|Uart_Rece_buffer[5]<<16|Uart_Rece_buffer[6]<<8|Uart_Rece_buffer[7];
            #ifdef USING_PRINTF
                    printf("Recv_Address:%x!\t",Recv_Address);
                    printf("Fota_Current_Addres:%x!\n",Fota_Struct.Fota_Current_Addres);
            #endif
            if ((Fota_Crc==Uart_Rece_buffer[Fota_Struct.Fota_Recv_Data_Len+9])&&(Fota_Struct.Fota_Current_Addres==Recv_Address))
            {
                #ifdef USING_PRINTF
                    printf("Fota_Crc:%x!\n",Fota_Crc);
                    printf("Fota_Current_Addres:%x!\n",Fota_Struct.Fota_Current_Addres);
                #endif
                Fota_Struct.Fota_update = TRUE;
                BSP_QSPI_Erase_Safe(Fota_Struct.Fota_Flash_Addres+Fota_Struct.Fota_Current_Addres,Fota_Struct.Fota_Recv_Data_Len);
                BSP_QSPI_Write_Safe(Uart_Rece_buffer+9,Fota_Struct.Fota_Flash_Addres+Fota_Struct.Fota_Current_Addres,Fota_Struct.Fota_Recv_Data_Len);
            }
            Fota_Struct.Fota_Current_Addres = Recv_Address + Fota_Struct.Fota_Recv_Data_Len;
            if (Fota_Struct.Fota_Current_Addres + Fota_Struct.Fota_Recv_Data_Len >Fota_Struct.Fota_All_Data_Len)
            {
                Fota_Struct.Fota_Recv_Data_Len = Fota_Struct.Fota_All_Data_Len - Fota_Struct.Fota_Current_Addres;
            }
            else
            {
                Fota_Struct.Fota_Recv_Data_Len = 0x64;
            }
            if(Fota_Struct.Fota_Recv_Data_Len==0)
            {
                #ifdef USING_PRINTF
                    printf("Done!\n");
                #endif
                appSetCFUN(0);
                #ifdef USING_PRINTF
                    for(int i=0;i<Fota_Struct.Fota_All_Data_Len;i++)
                    {
                        BSP_QSPI_Read_Safe(temp,Fota_Struct.Fota_Flash_Addres+i,1);
                        printf("%X ",temp[0]);
                    }
                #endif
                osDelay(1000);
                EC_SystemReset();

            }
            Uart_Send_buffer[0] = Fota_Struct.Fota_Current_Addres>>24;
            Uart_Send_buffer[1] = Fota_Struct.Fota_Current_Addres>>16;
            Uart_Send_buffer[2] = Fota_Struct.Fota_Current_Addres>>8;
            Uart_Send_buffer[3] = Fota_Struct.Fota_Current_Addres;
            Uart_Send_buffer[4] = Fota_Struct.Fota_Recv_Data_Len;
            USARTdrv->Send(Uart_Send_buffer,6);
        }
        else
        {
            USARTdrv->Send(Uart_Send_buffer,6);
            isRecvTimeout == false;
            memset(Uart_Rece_buffer,0,110);
        }
    }
}
// 字符串删除函数
void strdel(char * str,char c)
{
	char *p = str;
	while(*str)
	{
		if(*str!=c)
			*p++ = *str;
		str++;
	}
	*p = '\0';
}
//位置信息处理
uint32_t location_handle(char *in1)
{
	uint32_t location_temp;
	uint32_t location_degree;
	uint32_t location_min;
	location_temp = atol(in1);
	location_degree = location_temp/(1e7);
	location_degree = location_degree*(1e6);
	location_min = location_temp-location_degree*10;
	location_min = location_min/6;
	location_temp = location_degree+location_min;
	return location_temp;
} 
//Gps线程
static void Gps_Task(void* arg)
{
    gpsReqMsg msg;
	GPS_INFO Gps_buffer;
	Gps_buffer.latitude = 0xffffffff;
	Gps_buffer.longitude = 0xffffffff;
	char *p=NULL;
	const char *delim = "\n";
	char *databuffer[14];
    int data_index;
    osStatus_t Queue_flag;
	/**
	 *databuffer内容格式：
	 *  定位标识，时间，位置有效标识，纬度，纬度指示，经度，经度指示，地面速率，地面航向，日期
	 **/
    //posGGAServiceStart(norGpsHandle);
    while(1)
    {
        osDelay(1000);
	    //Queue_flag = osMessageQueueGet(norGpsHandle, &msg, 0, 2000);
        #ifdef USING_PRINTF	
            printf("Queue_flag [%d]\r\n",Queue_flag);
        #endif 
        if(Queue_flag==0)
        {
            /*
                    handle event
            */
            #ifdef USING_PRINTF	
                printf("GpsProcess [%d] %s\r\n",msg.len,msg.dataPtr);
            #endif 
            if(msg.dataPtr)
                free(msg.dataPtr);
            msg.dataPtr=NULL;
        }


        /**模拟测试结果解析正确
		char temp[] = "$GNRMC,082626.000,A,2939.91801,N,10637.09500,E,0.543,30.254,261120,,,A,V*17";
        #ifdef USING_PRINTF
            printf("temp:%s\n ",temp);
        #endif
        p = strtok(temp,",");//模拟测试
        #ifdef USING_PRINTF	
			printf("p:%s\r\n",p);
		#endif
        if (strcmp(p,"$GNRMC")==0)
        {
            data_index = 0;
            while (p)
            {	
                #ifdef USING_PRINTF	
                    printf("%s",p);
                #endif
                databuffer[data_index]=p;
                p = strtok(NULL,",");
                data_index++;;
            }
            #ifdef USING_PRINTF	
                printf("databuffer:\t");
                for (int i = 0; i < data_index; i++)
                {
                    printf("%s-",databuffer[i]);
                }
                printf("\n");
            #endif
            if (strcmp(databuffer[1],"V")==0|strcmp(databuffer[2],"V")==0)
            {
                #ifdef USING_PRINTF	
                    printf("Gpsdata invalide\n");
                #endif 
                Gps_buffer.status = 0x00;
                Gps_buffer.speed = 0xffff;
                Gps_buffer.direction= 0xffff;
            }
            else if (strcmp(databuffer[2],"A")==0)
            {
                uint32_t speedtemp;
                #ifdef USING_PRINTF	
                    printf("Gpsdata valide\n");
                #endif 
                Gps_buffer.status = 0x01;//有效，东经，北纬写定
                Gps_buffer.satellite_num = 03;//卫星数目写入1
                strdel(databuffer[3],'.');
                strdel(databuffer[5],'.');
                strdel(databuffer[7],'.');
                speedtemp = atol(databuffer[7])*1852;//节换算单位，1节=1.852km每小时
                Gps_buffer.speed = speedtemp/1e5;
                Gps_buffer.latitude = location_handle(databuffer[3]);
                Gps_buffer.longitude = location_handle(databuffer[5]);
                Gps_buffer.altitude = 00;
                if(Gps_buffer.speed>=100)//大于10km/h才输出方位
                {
                    Gps_buffer.direction = atol(databuffer[8]);
                }
                Gps_buffer.direction = 0xfffe;
            }
            #ifdef USING_PRINTF	
                printf("Gps_buffer:%x,%x,%x,%x",Gps_buffer.direction,Gps_buffer.speed,Gps_buffer.latitude,Gps_buffer.longitude);
            #endif
        }
        **/



		// //char temp[] = "$GNGGA,082626.00,2939.91801,N,10637.09500,E,1,03,2.34,-20.3,M,,M,,*40";
		// Queue_flag = osMessageQueueGet(norGpsHandle, &msg, 0, 1000);
        // #ifdef USING_PRINTF
        //     printf("Queue_flag:%d\n ",Queue_flag);
        // #endif
		// if (msg.dataPtr)
		// {		
			// void  *msgtemp = msg.dataPtr;//取指针
			// p = strtok(msg.dataPtr,delim);//将信息进行分割
            // #ifdef USING_PRINTF
            //     printf("%s ",msg.dataPtr);
            // #endif
			// p = strtok(p,",");//只取第1行的信息RMC
			// p = strtok(temp,",");//模拟测试
            // #ifdef USING_PRINTF	
			// 	printf("p:%s\r\n",p);
			// #endif
			// if (strcmp(p,"$GNRMC")==0)
			// {			
			// 	while (p)
			// 	{	
			// 		#ifdef USING_PRINTF	
			// 			printf("p:%s\r\n",p);
			// 		#endif
			// 		databuffer[i]=p;
			// 		p = strtok(NULL,",");
			// 		i++;;
			// 	}
			// 	if (strcmp(databuffer[1],"V")==0|strcmp(databuffer[2],"V")==0)
			// 	{

			// 		#ifdef USING_PRINTF	
			// 			printf("Gpsdata invalide\n");
			// 		#endif 
			// 		Gps_buffer.status = 0x00;
			// 		Gps_buffer.speed = 0xffff;
			// 		Gps_buffer.direction= 0xffff;

			// 	}
			// 	else if (strcmp(databuffer[2],"A")==0)
			// 	{
			// 		uint32_t speedtemp;
			// 		#ifdef USING_PRINTF	
			// 			printf("Gpsdata valide\n");
			// 		#endif 
			// 		Gps_buffer.status = 0x01;//有效，东经，北纬写定
			// 		Gps_buffer.satellite_num = 03;//卫星数目写入1
			// 		strdel(databuffer[3],'.');
			// 		strdel(databuffer[5],'.');
			// 		strdel(databuffer[7],'.');
			// 		speedtemp = atol(databuffer[7])*1852;//节换算单位，1节=1.852km每小时
			// 		Gps_buffer.speed = speedtemp/1e5;
			// 		Gps_buffer.latitude = location_handle(databuffer[3]);
			// 		Gps_buffer.longitude = location_handle(databuffer[5]);
			// 		Gps_buffer.altitude = 00;
			// 		if(Gps_buffer.speed>=100)//大于10km/h才输出方位
			// 		{
			// 			Gps_buffer.direction = atol(databuffer[8]);
			// 		}
			// 		Gps_buffer.direction = 0xfffe;
			// 	}
				// osMessageQueuePut(gpsMsgQueue, &Gps_buffer, 0, 1000);
			// }
		// 	free(msg.dataPtr);
		// 	msg.dataPtr=NULL;
		// }
		// msg.dataPtr=NULL;
		// if (Sleep_Flag)
		// {
        //     posGGAServiceStop();
		// 	osThreadExit();
		// 	break;
		// }
    }
}
//Uart线程初始化
void Uart_Task_Init()
{
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Uart_TaskStack, 0xA5, PROC_UART_TASK_STACK_SIZE);
    task_attr.name = "Uart_Task";
    task_attr.stack_mem = gProcess_Uart_TaskStack;
    task_attr.stack_size = PROC_UART_TASK_STACK_SIZE;
    task_attr.priority = osPriorityBelowNormal7;
    task_attr.cb_mem = &gProcess_Uart_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    osThreadNew(Uart_Task, NULL, &task_attr);
}
void Fota_Task_Init()
{
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Fota_TaskStack, 0xA5, PROC_FOTA_TASK_STACK_SIZE);
    task_attr.name = "Fota_Task";
    task_attr.stack_mem = gProcess_Fota_TaskStack;
    task_attr.stack_size = PROC_FOTA_TASK_STACK_SIZE;
    task_attr.priority = osPriorityBelowNormal7;
    task_attr.cb_mem = &gProcess_Fota_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    osThreadNew(Fota_Task, NULL, &task_attr);
}
//Gps线程初始化
void Gps_Task_Init()
{
    if(norGpsHandle == NULL)
	{
		norGpsHandle = osMessageQueueNew(1,sizeof(gpsReqMsg), NULL);
	}
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Gps_TaskStack, 0xA5, PROC_GPS_TASK_STACK_SIZE);
    task_attr.name = "Gps_Task";
    task_attr.stack_mem = gProcess_Gps_TaskStack;
    task_attr.stack_size = PROC_GPS_TASK_STACK_SIZE;
    task_attr.priority = osPriorityBelowNormal7;
    task_attr.cb_mem = &gProcess_Gps_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    osThreadNew(Gps_Task, NULL, &task_attr);
}
//主任务线程初始化
void Main_Task_Init()
{
    #ifndef USING_PRINTF
        if(BSP_GetPlatConfigItemValue(PLAT_CONFIG_ITEM_LOG_CONTROL) != 0)
        {
            HAL_UART_RecvFlowControl(false);
        }
    #endif
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Main_TaskStack, 0xA5, PROC_MAIN_TASK_STACK_SIZE);
    task_attr.name = "Main_Task";
    task_attr.stack_mem = gProcess_Main_TaskStack;
    task_attr.stack_size = PROC_MAIN_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;
    task_attr.cb_mem = &gProcess_Main_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    osThreadNew(Main_Task, NULL, &task_attr);
}
void appInit(void *arg)
{
    Main_Task_Init();
    Uart_Task_Init();
    Fota_Task_Init();
    //Gps_Task_Init();
}
//主函数入口
void main_entry(void) 
{
    BSP_CommonInit();
    osKernelInitialize();
    registerAppEntry(appInit, NULL);
    if (osKernelGetState() == osKernelReady)
    {
        osKernelStart();
    }
    while(1);
}
